package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateSubnetLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateSubnetLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateSubnetLogic {
	return &UpdateSubnetLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateSubnetLogic) UpdateSubnet(req *types.UpdateSubnetReq) (resp *types.UpdateSubnetResp, err error) {
	// todo: add your logic here and delete this line
	UpdateSubnetReq := &openstack.UpdateSubnetReq{}
	err = copier.CopyWithOption(UpdateSubnetReq, req, copier.Option{Converters: utils.Converters})
	UpdateSubnetResp, err := l.svcCtx.OpenstackRpc.UpdateSubnet(l.ctx, UpdateSubnetReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateSubnetResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateSubnetResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
